#!/usr/local/bin/perl

# -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#
# SPPDレンタルサーバー フォームメールCGI Ver1.15 管理画面
# (C) 2004-2017 Playing Network ,INC. All Rights Reserved.
# Programmed By Yasushi Toguchi
# 
# 著作権は株式会社プレイングネットワークに帰属します。
#
# -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

#-------------------------------#
# ●エンコード(POST&GET&COOKIE) #
#-------------------------------#
if($ENV{'REQUEST_METHOD'} eq "POST")
{
	read(STDIN,$str,$ENV{'CONTENT_LENGTH'});
	foreach(split('&',$str))
	{
		my($variable,$value)=split('=',$_);
		$value=~ tr/+/ /;
		$value=~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C",hex($1))/eg;
		$form{$variable} = $value;
	}
}
if($ENV{'QUERY_STRING'})
{
	foreach(split('&',$ENV{'QUERY_STRING'}))
	{
		my($variable,$value)=split('=',$_);
		$value=~ tr/+/ /;
		$value=~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C",hex($1))/eg;
		$url{$variable} = $value;
	}
}
if($ENV{'HTTP_COOKIE'})
{
	foreach(split('&',$ENV{'HTTP_COOKIE'}))
	{
		foreach (split(';',$_))
		{
			my($variable,$value)=split('=',$_);
			$value=~ tr/+/ /;
			$value=~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C",hex($1))/eg;
			$cookie{$variable} = $value;
		}
	}
}

#--------#
# ■定義 #
#--------#
$inc_files = "./include/";
$template_files = "./template/";
$passwdfile = "passwd.cgi";
$salt = "AB";
#$limit_path = $ENV{'REQUEST_URI'};
#$limit_path =~ s/[^\/]*$//g;

#----------------#
# ■設定ファイル #
#   606チェック  #
#----------------#
&ErrorMessage('adminフォルダのある ini.cgi のパーミッションが606に設定されていません。FTPソフト等でパーミッションを変更して下さい。') if(substr((sprintf "%03o", (stat("ini.cgi"))[2]), -3) != 606);
&ErrorMessage('adminフォルダにある passwd.cgi のパーミッションが606に設定されていません。FTPソフト等でパーミッションを変更して下さい。') if(substr((sprintf "%03o", (stat($passwdfile))[2]), -3) != 606);
#--------------#
# ■ログイン時 #
#--------------#
if($url{'action'} eq "login")
{
	open(PASSWD,"$passwdfile");
	$passwd = <PASSWD>;
	close(PASSWD);
	chop($passwd);

	$form{'passwd'} = crypt($form{'passwd'}, $salt);

	if($passwd eq $form{'passwd'})
	{
		# ログイン成功
		print "Location: ./\n";
		print "Set-Cookie: sppdfmuser=$form{'passwd'};\n\n";
		exit;
	}
	else
	{
		# ログイン失敗
		print "Location: ./index.cgi?mes=failed\n\n";
		exit;
	}
}

#----------------#
# ■ログアウト時 #
#----------------#
if($url{'action'} eq "logout")
{
	print "Location: ./\n";
	print "Set-Cookie: sppdfmuser=; expires=Thu, 01-Jan-1970 00:00:00 GMT;\n\n";
	exit;
}

#------------------------#
# ■チェックスクリプト＆ #
#   設定ファイル読み込み #
#------------------------#
require $inc_files."logincheck.cgi";
require "./ini.cgi";

if($url{'action'} eq "change_passwd")
{
	#------------------#
	# ■パスワード変更 #
	#------------------#
	require $inc_files."change_passwd.cgi";
	&change_passwd();
}
elsif($url{'action'} eq "maillog_action")
{
	#--------------#
	# ■メール編集 #
	#--------------#
	require $inc_files."maillog_action.cgi";
	&maillog_action();
}
elsif($url{'action'} eq "maildel")
{
	#--------------#
	# ■メール削除 #
	#--------------#
	require $inc_files."maillog_action.cgi";
	&maildel();
}
elsif($url{'action'} eq "setting")
{
	#------------#
	# ■設定変更 #
	#------------#
	require $inc_files."setting.cgi";
	&setting();
}
else
{
	#------------------#
	# ■デフォルト画面 #
	#------------------#
	require $inc_files."default.cgi";
	&default();
}
exit;


# ■エラーメッセージ表示
sub ErrorMessage
{
	my($Message) = @_[0];
	my($layout) = $template_files."error.html";

	print "Content-type: text/html\n\n";
	open(Error,"$layout");
	while(<Error>)
	{
		s/\%MESSAGE\%/$Message/g;
		print;
	}
	close(Error);
	exit;
}

